var intervalKeys = null;
var readKeys = false;
var mapKeys = {};

var intervalScreen = null;
var intervalSelection = null;
var documentWidth = 0;
var documentHeight = 0;

var intervalRocket = null;
var rocketX = 0;
var rocketY = 0;
var rocketS = 0;

var intervalBullets = null;
var noBullets = 25;
var bulletsC = [];
var bulletsX = [];
var bulletsY = [];
var bulletsS = [];

$(document).ready(function () {
    $(this).keydown(function (e) {
        e = e || event;
        mapKeys[e.keyCode] = e.type === 'keydown';
        if (readKeys === true) {
            e.preventDefault();
        }
    });
    $(this).keyup(function (e) {
        e = e || event;
        mapKeys[e.keyCode] = e.type === 'keydown';
        if (readKeys === true) {
            e.preventDefault();
        }
    });
    setupGame();
});

function setupGame() {
    clearIntervals();
    readKeys = false;
    if ($("#gamediv").length !== 0) {
        $("#gamediv").empty();
        $("#gamediv").remove();
    }
    var $div = $('<div />').appendTo('body');
    $div.attr('id', 'gamediv');
}

function startGame() {
    readKeys = true;

    documentWidth = $(window).width();
    documentHeight = $(window).height();

    $('#gamediv').css('display', 'none');
    $('#gamediv').css('top', '25px');
    $('#gamediv').css('left', '25px');
    $('#gamediv').css('width', (documentWidth - 50) + 'px');
    $('#gamediv').css('height', (documentHeight - 50) + 'px');
    $('#gamediv').html();
    $('#gamediv').addClass('gamediv');

    var $div = $('<div />').appendTo('#gamediv');
    $div.attr('id', 'gametitle');
    $('#gametitle').css('top', '25px');
    $('#gametitle').css('left', '0px');
    $('#gametitle').css('width', ($('#gamediv').width()) + 'px');
    $('#gametitle').addClass('gametitle');
    $('#gametitle').html('<h1 class="gametitle">COMPUTER IDEE INVADERS</h1><h5 class="gametitle">- een niet al te serieuze it-extravangantie door john vanderaart -<h5>');

    $div = $('<div />').appendTo('#gamediv');
    $div.attr('id', 'rocketdiv');
    $('#rocketdiv').css('display', 'none');
    $('#rocketdiv').addClass('rocket');
    $('#rocketdiv').html('<i class="fas fa-space-shuttle fa-rotate-270 fa-6x rocket-color"></i>');
    rocketX = ((documentWidth - 50) / 2) - 43;
    rocketY = -120;
    rocketS = 0;

    initBullets();

    intervalScreen = setInterval(handleScreen, 25);
    intervalKeys = setInterval(handleKeys, 150);
    intervalSelection = setInterval(handleSelection, 150);
    intervalRocket = setInterval(handleRocket, 50);
    intervalBullets = setInterval(handleBullets, 50);

    $('#gamediv').css('display', '');
}

function clearIntervals() {
    if (intervalScreen !== null) {
        clearInterval(intervalScreen);
    }
    if (intervalScreen !== null) {
        clearInterval(intervalKeys);
    }
    if (intervalSelection !== null) {
        clearInterval(intervalSelection);
    }
    if (intervalRocket !== null) {
        clearInterval(intervalRocket);
    }
    if (intervalBullets !== null) {
        clearInterval(intervalBullets);
    }
}

function handleScreen() {
    documentWidth = $(window).width();
    documentHeight = $(window).height();
    $('#gamediv').css('width', (documentWidth - 50) + 'px');
    $('#gamediv').css('height', (documentHeight - 50) + 'px');
    $('#gametitle').css('width', $('#gamediv').width() + 'px');
}

function handleKeys() {
    if (mapKeys[27]) {
        setupGame();
    }
    if (mapKeys[32]) {
        fireBullet();
    }
    if (mapKeys[37]) {
        rocketS = rocketS + 2;
        if (rocketS > 25) {
            rocketS = 25;
        }
        rocketX = rocketX - rocketS;
        if (rocketX < 10) {
            rocketX = 10;
        }
    }
    if (mapKeys[38]) {
        if (rocketY > 250) {
            rocketY = rocketY - 50;
        }
    }
    if (mapKeys[39]) {
        rocketS = rocketS + 2;
        if (rocketS > 25) {
            rocketS = 25;
        }
        rocketX = rocketX + rocketS;
    }
}

function handleSelection() {
    if (window.getSelection) {
        if (window.getSelection().empty) {
            window.getSelection().empty();
        } else if (window.getSelection().removeAllRanges) {
            window.getSelection().removeAllRanges();
        }
    } else if (document.selection) {
        document.selection.empty();
    }
}

function handleRocket() {
    if (rocketX > ($('#gamediv').width() - 135)) {
        rocketX = $('#gamediv').width() - 135;
    }
    if (rocketY < ($('#gamediv').height() - 135)) {
        rocketY = rocketY + 5;
    }
    if (rocketY > ($('#gamediv').height() - 135)) {
        rocketY = $('#gamediv').height() - 135;
    }
    $('#rocketdiv').css('left', (rocketX) + 'px');
    $('#rocketdiv').css('top', (rocketY) + 'px');
    $('#rocketdiv').css('display', '');
}

function initBullets() {
    for (i = 0; i < noBullets; i++) {
        bulletsC[i] = 0;
        bulletsX[i] = 0;
        bulletsY[i] = 0;
        bulletsS[i] = 0;
        $div = $('<div />').appendTo('#gamediv');
        $div.attr('id', 'bulletdiv' + i);
        $('#bulletdiv' + i).css('display', 'none');
        $('#bulletdiv' + i).addClass('bullet');
    }
}

function fireBullet() {
    for (i = 0; i < noBullets; i++) {
        if (bulletsC[i] === 0) {
            switch (Math.floor(Math.random() * 6)) {
                case 0:
                    $('#bulletdiv' + i).html('<i class="far fa-spin fa-2x bullet0"></i>');
                    break;
                case 1:
                    $('#bulletdiv' + i).html('<i class="far fa-spin-reverse fa-2x bullet1"></i>');
                    break;
                case 2:
                    $('#bulletdiv' + i).html('<i class="far fa-spin fa-2x bullet2"></i>');
                    break;
                case 3:
                    $('#bulletdiv' + i).html('<i class="far fa-spin-reverse fa-2x bullet3"></i>');
                    break;
                case 4:
                    $('#bulletdiv' + i).html('<i class="far fa-spin fa-2x bullet4"></i>');
                    break;
                case 5:
                    $('#bulletdiv' + i).html('<i class="far fa-spin-reverse fa-2x bullet5"></i>');
                    break;
            }
            bulletsC[i] = 1;
            bulletsX[i] = rocketX + 44;
            bulletsY[i] = rocketY - 44;
            bulletsS[i] = 5;
            break;
        }
    }
}

function handleBullets() {
    for (i = 0; i < noBullets; i++) {
        if (bulletsC[i] !== 0) {
            if (bulletsC[i] === 1) {
                if (bulletsX[i] > ($('#gamediv').width() - 90)) {
                    bulletsX[i] = $('#gamediv').width() - 90;
                }
                bulletsY[i] = bulletsY[i] - bulletsS[i];
                $('#bulletdiv' + i).css('left', (bulletsX[i]) + 'px');
                $('#bulletdiv' + i).css('top', (bulletsY[i]) + 'px');
                $('#bulletdiv' + i).css('display', '');
                if (bulletsY[i] < -55) {
                    bulletsC[i] = 0;
                    $('#bulletdiv' + i).html();
                    $('#bulletdiv' + i).css('display', 'none');
                }
            }
            if (bulletsC[i] > 1) {
                bulletsC[i]++;
                if (bulletsC[i] === 25) {
                    bulletsC[i] = 0;
                    $('#bulletdiv' + i).html();
                    $('#bulletdiv' + i).css('display', 'none');
                }
            }
        }
    }
}